<template>
  <div class="flex items-center">
    <select
      v-model="selectedDimension"
      class="mr-2 border"
    >
      <option
        v-for="dimension of dimensions"
        :key="dimension"
        :value="dimension"
      >
        {{ dimension }}
      </option>
    </select>

    <select
      v-if="selectedDimension"
      v-model="ruleType"
      class="mr-2 border"
    >
      <option
        v-for="{code, text} of ruleTypesForDimension"
        :key="code"
        class="mx-4"
        :value="code"
      >
        {{ text }}
      </option>
    </select>

    <template v-if="ruleType === 'inSet' || ruleType === 'outSet'">
      <SetSelector
        v-model="ruleContent"
        :values="values"
      />
    </template>

    <template v-else-if="ruleType === 'inInterval' || ruleType === 'outInterval'">
      <IntervalSelector
        v-model="ruleContent"
        :values="values"
      />
    </template>

    <template v-else-if="ruleType === 'lowerThan' || ruleType === 'greaterThan'">
      <SingleSelector
        v-model="ruleContent"
        :values="values"
      />
    </template>

    <template v-else-if="ruleType === 'contain_themes'">
      <ThemesSelector
        v-model="ruleContent"
        :values="values"
      />
    </template>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Model, Prop, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import IntervalSelector from './IntervalSelector.vue'
import SetSelector from './SetSelector.vue'
import SingleSelector from './SingleSelector.vue'
import ThemesSelector from './ThemesSelector.vue'

import _ from 'lodash/fp'

const ruleTypes = [
  { code: 'inSet', text: 'in' },
  { code: 'outSet', text: 'not in' },
  { code: 'contain_themes', text: 'has' }
  /* { code: 'inInterval', text: 'in interval' }, */
  /* { code: 'outInterval', text: 'not in interval' }, */
  /* { code: 'lowerThan', text: 'lower than' }, */
  /* { code: 'greaterThan', text: 'greater than' } */
]

const getRuleType = _.compose([
  _.find((key) => (_.includes)(key)(_.map(_.get('code'), ruleTypes))),
  _.keys])

const defaultRuleContent = (ruleType) => {
  switch (ruleType) {
    case 'inSet':
    case 'outSet':
    case 'inInterval':
    case 'outInterval':
    case 'contain_themes':
      return []
    case 'lowerThan':
    case 'greaterThan':
    default:
      return null
  }
}

const getRuleContent = (rule) => {
  const ruleType = getRuleType(rule)
  return _.getOr(defaultRuleContent(ruleType), ruleType, rule)
}

@Component({
  components: {
    IntervalSelector,
    SetSelector,
    SingleSelector,
    ThemesSelector
  }
})
export default class RuleCreator extends Vue {
  @Model('rule', {
    default () {
      return {}
    }
  }) enterRule

  @Prop(Array) dimensions
  @Prop(Array) data

  @State settings

  filter = ''
  ruleType = getRuleType(this.enterRule) || null
  ruleTypes = ruleTypes
  ruleContent = getRuleContent(this.enterRule)
  selectedDimension = _.getOr(null, 'dimensionName', this.enterRule) as any as string

  get values () {
    const sort = (() => {
      if (_.includes(this.selectedDimension, this.settings.numericHeader)) {
        // TODO rethink this. Thing is, the datasets don't really discriminate
        // strings from numbers, so everything gets a bit weird
        // return arr => _.filter(_.negate(_.isNaN))(_.map(x => parseInt(x, 10) || parseFloat(x))(arr)).sort((a, b) => a - b)

        return (arr) => arr.sort()
      } else if (_.includes(this.selectedDimension, this.settings.arrayHeader)) {
        return (arr) => {
          // eslint-disable-next-line
          const values = _.flatten(_.map(eval)(arr))
          return values.sort()
        }
      } else {
        return (arr) => arr.sort()
      }
    })()

    const values = _.map(_.get(this.selectedDimension))(this.data)
    return _.sortedUniq(sort(values))
  }

  get ruleTypesForDimension () {
    if (_.contains(this.selectedDimension, this.settings.arrayHeader)) {
      return _.filter(_.compose([_.eq('contain_themes'), _.get('code')]))(ruleTypes)
    } else {
      return _.filter(_.negate(_.compose([_.eq('contain_themes'), _.get('code')])))(ruleTypes)
    }
  }

  get rule () {
    return { dimensionName: this.selectedDimension, [this.ruleType]: this.ruleContent || defaultRuleContent(this.ruleType) }
  }

  @Watch('selectedDimension')
  onSelectedDimensionChanged () {
    this.filter = ''
    this.ruleContent = defaultRuleContent(this.ruleType)
  }

  @Watch('enterRule')
  onEnterRuleChanged () {
    this.selectedDimension = _.getOr(null, 'dimensionName', this.enterRule) as any as string
    this.ruleType = getRuleType(this.enterRule)
    this.ruleContent = getRuleContent(this.enterRule)
  }

  @Watch('rule')
  onRuleChanged () {
    this.emitRule()
  }

  // If ruleType changes to a compatible type, try to keep the rule content,
  // else pick the default
  @Watch('ruleType')
  onRuleTypeChanged (o, n) {
    if ((o === 'inSet' && n === 'outSet') ||
        (o === 'outSet' && n === 'inSet') ||
        (o === 'inInterval' && n === 'outInterval') ||
        (o === 'outInterval' && n === 'inInterval') ||
        (o === 'lowerThan' && n === 'greaterThan') ||
        (o === 'greaterThan' && n === 'lowerThan')) {
      this.ruleContent = this.ruleContent || defaultRuleContent(this.ruleType)
    } else {
      this.ruleContent = defaultRuleContent(this.ruleType)
    }
  }

  emitRule () {
    if (!_.isEmpty(getRuleContent(this.rule))) {
      this.$emit('rule', this.rule)
    }
  }
}
</script>
